## why3 1.4.0

=== examples/multiprecision/Makefile ===
BENCH ?= no
OVERLAY ?= no
LOCAL ?= $(BENCH)

ifeq ($(LOCAL),yes)
  WHY3=../../bin/why3.opt
else
  ifeq ($(BINDIR),)
    WHY3=why3
  else
    WHY3=$(BINDIR)/why3
  endif
endif

ifndef CFLAGS
  ifdef GMP_DIR
    CFLAGS = $(shell sed -n -e 's/^CFLAGS = \(.*\)/\1/p' $(GMP_DIR)/Makefile)
  else
    CFLAGS = -march=native -O2 -fomit-frame-pointer
  endif
endif

ifdef GMP_LIB
  GMPFLAGS = -I$(GMP_LIB)/include -L$(GMP_LIB)/lib
endif

CFLAGS += -Wall -Wno-unused -g -std=c11 -Wno-pedantic

.PHONY: all clean extract plots benchs why3benchs gmpbenchs minigmpbenchs

all: extract

clean:
	rm -rf build bench

why3:
	make -C ../..

MLWFILES = \
  mpz_get_str mpz_set_str mpz_div2exp mpz_mul2exp mpz_div mpz_mul mpz_sub mpz_add mpz_getset mpz_abs mpz_cmp mpz_cmpabs mpz \
  set_str get_str base_info powm sqrtrem sqrt toom logical div mul sub add compare util

build/extracted: $(addsuffix .mlw, $(MLWFILES))
	mkdir -p build
	rm -f $@
	$(WHY3) extract -D wmpn.drv -D c -L . --recursive --modular --interface -o build/ \
	  --debug=c_no_error_msgs wmpn.mlw
	touch $@

build/sqrtinit.h: sqrtinit.ml
	mkdir -p build
	ocaml sqrtinit.ml > build/sqrtinit.h

build/binverttab.h: binverttab.ml
	mkdir -p build
	ocaml binverttab.ml > build/binverttab.h

EXTRACTED = build/extracted build/sqrtinit.h build/binverttab.h

extract: $(EXTRACTED)

CFILES = \
  zutil.c z.c zcmp.c zcmpabs.c zabs.c zadd.c zsub.c zmul.c zdiv.c zmul2exp.c zdiv2exp.c zget_str.c zset_str.c \
  set.c get_str.c set_str.c baseinfo.c powm.c sqrt.c sqrt1.c toom.c div.c \
  logical.c logicalold.c logicalutil.c mul_basecase.c sub.c sub_1.c add.c add_1.c \
  compare.c util.c utilold.c

ifneq ($(OVERLAY),gmp)
CFILES += mul.c addold.c subold.c
endif

gmp_INCLUDES = mul.h add.h sub.h
mini_INCLUDES = uint64gmp.h
no_INCLUDES =
INCLUDES = $($(OVERLAY)_INCLUDES)

build/libwmp.a: $(EXTRACTED)
	cd build; $(CC) $(CFLAGS) $(INCLUDES:%=-include ../overlays/%) -c $(CFILES)
	ar rcs $@ $(addprefix build/,$(CFILES:.c=.o))

build/tests: tests.c build/libwmp.a
	$(CC) $(CFLAGS) tests.c -Irandom -Lbuild -lm -lwmp -lgmp -o $@

build/minitests: tests.c build/libwmp.a
	$(CC) $(CFLAGS) -DCOMPARE_MINI tests.c -Irandom -Imini-gmp -Lbuild -lm -lwmp -o $@

UPPER = $(shell echo $* | tr [:lower:] [:upper:])

build/why3%bench: tests.c build/libwmp.a
	$(CC) $(CFLAGS) -DTEST_WHY3 -DTEST_$(UPPER) tests.c -Iinclude -Irandom -Lbuild -lm -lwmp -lgmp -o $@

build/gmp%bench: tests.c build/libwmp.a
	$(CC) $(CFLAGS) $(GMPFLAGS) -DTEST_GMP -DTEST_$(UPPER) tests.c -Iinclude -Irandom -lm -lgmp -o $@

build/minigmp%bench: tests.c build/libwmp.a
	$(CC) $(CFLAGS) -DTEST_MINIGMP -DTEST_$(UPPER) tests.c -Iinclude -Imini-gmp -Irandom -lm -o $@

BENCHS = toomb sqrtrem millerrabin toomu add mul div powm toomm


WHY3BENCHFILES = $(addprefix bench/why3, $(BENCHS))
GMPBENCHFILES = $(addprefix bench/gmp, $(BENCHS))
MINIGMPBENCHFILES = $(addprefix bench/minigmp, $(BENCHS))
BENCHFILES = $(WHY3BENCHFILES) $(GMPBENCHFILES) $(MINIGMPBENCHFILES)

$(BENCHFILES): bench/%: build/%bench
	mkdir -p bench
	$< > $@

why3benchs: $(WHY3BENCHFILES)
gmpbenchs: $(GMPBENCHFILES)
minigmpbenchs: $(MINIGMPBENCHFILES)
benchs: why3benchs gmpbenchs minigmpbenchs

plots: $(BENCHFILES)
	make all -C plots

=== debian/changelog ===
why3 (1.4.0-3) unstable; urgency=medium

  * Update Recommends and test-dependencies of why3: cvc4 up to 1.8, z3 up
    to 4.8.10
  * Build-dependency on ocamlgraph and coq: add version constraints
    according to upstream opam file
  * Use a debian/control.in to fill in automatically the native architectures
    on which coq is available
  * Update why3 manpage to document the new syntax of "why3 config"
  * Add debian/upstream/metadata

 -- Ralf Treinen <treinen@debian.org>  Sat, 11 Dec 2021 11:37:13 +0100

why3 (1.4.0-2) unstable; urgency=medium

  * Team upload
  * Fix autopkgtests

 -- Stéphane Glondu <glondu@debian.org>  Wed, 24 Nov 2021 08:49:42 +0100

why3 (1.4.0-1) unstable; urgency=medium

  * Team upload
  * New upstream release
    - Backport Coq 8.14 support from upstream git
  * Bump Standards-Version to 4.6.0
  * Update debian/watch

 -- Stéphane Glondu <glondu@debian.org>  Tue, 23 Nov 2021 14:26:23 +0100

=== debian/control ===
Source: why3
Section: math
Priority: optional
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders: Ralf Treinen <treinen@debian.org>
Build-Depends:
  debhelper-compat (= 13), dh-ocaml,
  autoconf,
  ocaml-nox (>= 4.05.5),
  ocaml-findlib,
  menhir (>= 20200123),
  libmenhir-ocaml-dev (>= 20200123),
  libzarith-ocaml-dev,
  libsqlite3-ocaml-dev,
  libzip-ocaml-dev,
  libnum-ocaml-dev,
  libocamlgraph-ocaml-dev (>= 1.8.2),
  coq (>= 8.7) [amd64 arm64 armhf hurd-i386 i386 kfreebsd-i386 kfreebsd-amd64  ppc64 ppc64el sparc s390x riscv64],
  libcoq-ocaml-dev (>= 8.7) [amd64 arm64 armhf hurd-i386 i386 kfreebsd-i386 kfreebsd-amd64  ppc64 ppc64el sparc s390x riscv64],
  liblablgtk3-ocaml-dev, liblablgtksourceview3-ocaml-dev,
  tex-common
Build-Depends-Indep:
  python3-sphinx, python3-sphinxcontrib.bibtex,
  texlive-plain-generic,
  texlive-latex-recommended, texlive-latex-extra,
  texlive-fonts-recommended,
  texlive-bibtex-extra,
  tex-gyre,
  graphviz
Standards-Version: 4.6.0
Rules-Requires-Root: no
Homepage: http://why3.lri.fr/
Vcs-Git: https://salsa.debian.org/ocaml-team/why3.git
Vcs-Browser: https://salsa.debian.org/ocaml-team/why3

Package: why3
Architecture: any
Depends:
  ${shlibs:Depends},
  ${ocaml:Depends},
  ${misc:Depends},
Recommends: cvc4 (<< 1.9) | why3-coq [amd64 arm64 armhf hurd-i386 i386 kfreebsd-i386 kfreebsd-amd64  ppc64 ppc64el sparc s390x riscv64]| spass | z3 (<< 4.8.11) | alt-ergo (>= 2.0.0)
Suggests: why3-examples
Description: Software verification platform
 Why3 is a platform for deductive program verification. It provides a
 rich language for specification and programming, called WhyML, and
 relies on external theorem provers, both automated and interactive,
 to discharge verification conditions. Why3 comes with a standard
 library of logical theories (integer and real arithmetic, Boolean
 operations, sets and maps, etc.) and basic programming data
 structures (arrays, queues, hash tables, etc.). A user can write
 WhyML programs directly and get correct-by-construction OCaml
 programs through an automated extraction mechanism. WhyML is also
 used as an intermediate language for the verification of C, Java, or
 Ada programs.
 .
 Why3 is a complete reimplementation of the former Why platform. Among
 the new features are: numerous extensions to the input language, a
 new architecture for calling external provers, and a well-designed
 API, allowing to use Why3 as a software library. An important
 emphasis is put on modularity and genericity, giving the end user a
 possibility to easily reuse Why3 formalizations or to add support for
 a new external prover if wanted.

Package: why3-coq
Architecture: amd64 arm64 armhf hurd-i386 i386 kfreebsd-i386 kfreebsd-amd64  ppc64 ppc64el sparc s390x riscv64
Depends: coq-${F:CoqABI}, ${misc:Depends}, ${ocaml:Depends}, ${shlibs:Depends}
Recommends: why3
Description: Coq support for the why3 verification platform
 This package contains the compiled coq files that are necessary to
 use the coq proof assistant together with the why3 deductive
 verification platform.

Package: libwhy3-ocaml-dev
Architecture: any
Depends: ${misc:Depends}, ${ocaml:Depends}, ${shlibs:Depends}
Suggests: ocaml-findlib
Provides: ${ocaml:Provides}
Section: ocaml
Description: OCaml librariries for why3 (dev)
 This package contains the libraries of the why3 verification platform
 for developing applications using why3.

Package: why3-examples
Architecture: all
Depends: ${misc:Depends}
Recommends: why3
Description: Examples for the why3 verification platform
 This package contains examples, both of program verification tasks
 and pure logical verification tasks, for the why3 software verification
 platform.

Package: why3-doc-html
Architecture: all
Depends: ${misc:Depends},
  libjs-jquery,
  libjs-underscore,
  libjs-mathjax,
  libjs-sphinxdoc
Suggests: why3
Description: HTML Documentation of the why3 verification platform
 This package contains the tutorial and reference manual of the
 why3 verification platform in HTML format.

Package: why3-doc-pdf
Architecture: all
Depends: ${misc:Depends}
Suggests: why3
Description: PDF Documentation of the why3 verification platform
 This package contains the tutorial and reference manual of the
 why3 verification platform in PDF format.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/ocaml/ocamlvars.mk
OCAML_NATIVE_ARCHS := $(subst lpia,,$(OCAML_NATIVE_ARCHS))

BUILDDIR=debian/tmp

HAVE_COQVARS ?= $(if $(wildcard /usr/share/coq/coqvars.mk),yes,no)

ifeq ($(HAVE_COQVARS),yes)
  include /usr/share/coq/coqvars.mk
endif

%:
	dh $@ --with ocaml,tex

# Should never be called automatically.
.PHONY: debian/control
debian/control:
	sed -e 's/@OCamlNativeArchs@/$(OCAML_NATIVE_ARCHS)/g' debian/control.in > $@

override_dh_auto_configure:
	autoconf
	dh_auto_configure -- \
		--disable-emacs-compilation \
		--libdir=/usr/lib/ocaml

override_dh_auto_build-arch:
	$(MAKE) all byte

override_dh_auto_build-indep:
	$(MAKE) doc
	cd doc/html; \
	for f in *.html; do \
	  sed -e "s|https://cdnjs.cloudflare.com/ajax/libs/mathjax/[0-9.]\+/latest.js|/usr/share/javascript/mathjax/MathJax.js|" $$f > $$f.out; \
	  mv $$f.out $$f; \
	done

override_dh_auto_install:
	# do nothing

override_dh_install-arch: build-arch
	$(MAKE) install install-lib DESTDIR=$(CURDIR)/$(BUILDDIR)
	dh_install -a -XLICENSE
ifeq ($(HAVE_COQVARS),yes)
	echo 'F:CoqABI=$(COQ_ABI)' >> debian/why3-coq.substvars
endif

override_dh_install-indep:
	# do nothing

override_dh_installexamples:
	dh_installexamples
	if [ -d debian/why3-examples/usr/share/doc/why3-examples/examples ]; \
	then \
	  find debian/why3-examples/usr/share/doc/why3-examples/examples \
	    -name why3shapes.gz \
	    -exec sh -c 'if [ $$(zcat {} | wc -c) -eq 0 ]; then \rm {}; fi' \;;\
	fi

override_dh_compress:
	dh_compress -Xmanual.pdf

ifneq ($(wildcard debian/why3/usr/lib/ocaml/why3/commands/why3ide.cmxs),)
  WHY3IDE_NODEFINED_MAP := --nodefined-map=why3:Graph,$(shell ocamlobjinfo debian/why3/usr/lib/ocaml/why3/commands/why3ide.cmxs | sed -n 's/Name: //p' | xargs echo | tr ' ' ,)
else
  WHY3IDE_NODEFINED_MAP :=
endif

override_dh_ocaml:
	dh_ocaml --nodefined-map=why3-coq:Why3,MenhirLib,Gzip,Zlib,Zip \
	  $(WHY3IDE_NODEFINED_MAP)

=== debian/tests/control ===
Tests: why3+alt-ergo
Depends: why3, alt-ergo (>= 2.0.0)
Restrictions: skip-not-installable

Tests: why3+cvc4
Depends: why3, cvc4 (<< 1.9)
Restrictions: skip-not-installable

Tests: why3+spass
Depends:why3, spass
Restrictions: skip-not-installable

Tests: why3+z3
Depends:why3, z3 (<< 4.8.11)
Restrictions: skip-not-installable

Tests: why3+coq
Depends: why3, why3-coq, coq
Restrictions: skip-not-installable

## why3 1.4.1

=== debian/changelog ===
why3 (1.4.1-2) unstable; urgency=medium

  * Fix compilation on bytecode architectures, on these architectures we
    have to look for exported units in why3ide.cma.

 -- Ralf Treinen <treinen@debian.org>  Sat, 19 Mar 2022 15:01:40 +0100

why3 (1.4.1-1) unstable; urgency=medium

  * New upstream release.
  * New patch ocamlgraph-cma to cope with the fact that ocamlgraph does no
    longer produce graph.cmo (closes: #1003801)
  * Drop building of the why3-coq package.
    
 -- Ralf Treinen <treinen@debian.org>  Sat, 19 Mar 2022 12:16:02 +0100

=== debian/control ===
--- 
+++ 
@@ -15,8 +15,6 @@
   libzip-ocaml-dev,
   libnum-ocaml-dev,
   libocamlgraph-ocaml-dev (>= 1.8.2),
-  coq (>= 8.7) [amd64 arm64 armhf hurd-i386 i386 kfreebsd-i386 kfreebsd-amd64  ppc64 ppc64el sparc s390x riscv64],
-  libcoq-ocaml-dev (>= 8.7) [amd64 arm64 armhf hurd-i386 i386 kfreebsd-i386 kfreebsd-amd64  ppc64 ppc64el sparc s390x riscv64],
   liblablgtk3-ocaml-dev, liblablgtksourceview3-ocaml-dev,
   tex-common
 Build-Depends-Indep:
@@ -39,7 +37,7 @@
   ${shlibs:Depends},
   ${ocaml:Depends},
   ${misc:Depends},
-Recommends: cvc4 (<< 1.9) | why3-coq [amd64 arm64 armhf hurd-i386 i386 kfreebsd-i386 kfreebsd-amd64  ppc64 ppc64el sparc s390x riscv64]| spass | z3 (<< 4.8.11) | alt-ergo (>= 2.0.0)
+Recommends: cvc4 (<< 1.9) | spass | z3 (<< 4.8.11) | alt-ergo (>= 2.0.0)
 Suggests: why3-examples
 Description: Software verification platform
  Why3 is a platform for deductive program verification. It provides a
@@ -61,15 +59,6 @@
  emphasis is put on modularity and genericity, giving the end user a
  possibility to easily reuse Why3 formalizations or to add support for
  a new external prover if wanted.
-
-Package: why3-coq
-Architecture: amd64 arm64 armhf hurd-i386 i386 kfreebsd-i386 kfreebsd-amd64  ppc64 ppc64el sparc s390x riscv64
-Depends: coq-${F:CoqABI}, ${misc:Depends}, ${ocaml:Depends}, ${shlibs:Depends}
-Recommends: why3
-Description: Coq support for the why3 verification platform
- This package contains the compiled coq files that are necessary to
- use the coq proof assistant together with the why3 deductive
- verification platform.
 
 Package: libwhy3-ocaml-dev
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -5,19 +5,8 @@
 
 BUILDDIR=debian/tmp
 
-HAVE_COQVARS ?= $(if $(wildcard /usr/share/coq/coqvars.mk),yes,no)
-
-ifeq ($(HAVE_COQVARS),yes)
-  include /usr/share/coq/coqvars.mk
-endif
-
 %:
 	dh $@ --with ocaml,tex
-
-# Should never be called automatically.
-.PHONY: debian/control
-debian/control:
-	sed -e 's/@OCamlNativeArchs@/$(OCAML_NATIVE_ARCHS)/g' debian/control.in > $@
 
 override_dh_auto_configure:
 	autoconf
@@ -42,9 +31,6 @@
 override_dh_install-arch: build-arch
 	$(MAKE) install install-lib DESTDIR=$(CURDIR)/$(BUILDDIR)
 	dh_install -a -XLICENSE
-ifeq ($(HAVE_COQVARS),yes)
-	echo 'F:CoqABI=$(COQ_ABI)' >> debian/why3-coq.substvars
-endif
 
 override_dh_install-indep:
 	# do nothing
@@ -62,11 +48,12 @@
 	dh_compress -Xmanual.pdf
 
 ifneq ($(wildcard debian/why3/usr/lib/ocaml/why3/commands/why3ide.cmxs),)
-  WHY3IDE_NODEFINED_MAP := --nodefined-map=why3:Graph,$(shell ocamlobjinfo debian/why3/usr/lib/ocaml/why3/commands/why3ide.cmxs | sed -n 's/Name: //p' | xargs echo | tr ' ' ,)
+  WHY3IDE_UNITS := $(shell ocamlobjinfo debian/why3/usr/lib/ocaml/why3/commands/why3ide.cmxs | sed -n 's/Name: //p' | xargs echo | tr ' ' ,)
 else
-  WHY3IDE_NODEFINED_MAP :=
+  WHY3IDE_UNITS := $(shell ocamlobjinfo debian/why3/usr/lib/ocaml/why3/commands/why3ide.cma | sed -n 's/Unit name: //p' | xargs echo | tr ' ' ,)
 endif
 
+WHY3HYPO_UNITS := $(shell ocamlobjinfo debian/why3/usr/lib/ocaml/why3/plugins/hypothesis_selection.cma | sed -n 's/Unit name: //p' | xargs echo | tr ' ' ,)
+
 override_dh_ocaml:
-	dh_ocaml --nodefined-map=why3-coq:Why3,MenhirLib,Gzip,Zlib,Zip \
-	  $(WHY3IDE_NODEFINED_MAP)
+	dh_ocaml --nodefined-map=why3:$(WHY3IDE_UNITS),$(WHY3HYPO_UNITS)

=== debian/tests/control ===
--- 
+++ 
@@ -13,7 +13,3 @@
 Tests: why3+z3
 Depends:why3, z3 (<< 4.8.11)
 Restrictions: skip-not-installable
-
-Tests: why3+coq
-Depends: why3, why3-coq, coq
-Restrictions: skip-not-installable

## why3 1.5.0

=== debian/changelog ===
why3 (1.5.0-1build1) kinetic; urgency=medium

  * Rebuild against new OCAML ABI.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 14 May 2022 07:24:40 +0200

why3 (1.5.0-1) unstable; urgency=medium

  * New upstream version.
  * Refresh patch hardening-flags.
  * Drop patch ocamlgraph-cma, issue has been fixed upstream.
  * debian/rules: configure with option --disable-coq-libs, so that
    we are sure that coq stuff is not build.
  * Bump dependency on z3 to (<< 4.8.16).
  * Simplify test why3+z3: drop preliminary testing of z3.

 -- Ralf Treinen <treinen@debian.org>  Tue, 03 May 2022 08:00:48 +0200

=== debian/control ===
--- 
+++ 
@@ -37,7 +37,7 @@
   ${shlibs:Depends},
   ${ocaml:Depends},
   ${misc:Depends},
-Recommends: cvc4 (<< 1.9) | spass | z3 (<< 4.8.11) | alt-ergo (>= 2.0.0)
+Recommends: cvc4 (<< 1.9) | spass | z3 (<< 4.8.16) | alt-ergo (>= 2.0.0)
 Suggests: why3-examples
 Description: Software verification platform
  Why3 is a platform for deductive program verification. It provides a

=== debian/tests/control ===
--- 
+++ 
@@ -11,5 +11,5 @@
 Restrictions: skip-not-installable
 
 Tests: why3+z3
-Depends:why3, z3 (<< 4.8.11)
+Depends:why3, z3 (<< 4.8.16)
 Restrictions: skip-not-installable

## why3 1.5.1

=== examples/gcd/Makefile ===

BENCH ?= no

ifeq ($(BENCH),yes)
  WHY3=../../bin/why3.opt
  WHY3SHARE=../../share
else
  ifeq ($(BINDIR),)
    WHY3=why3
  else
    WHY3=$(BINDIR)/why3
  endif
  WHY3SHARE=$(shell $(WHY3) --print-datadir)
endif

include $(WHY3SHARE)/Makefile.config

ifeq ($(BENCH),yes)
  INCLUDE += -I ../../lib/why3
endif

MAIN=main
GEN=euclideanAlgorithm63
OBJ=$(GEN)

GENML = $(addsuffix .ml, $(GEN))
ML = $(addsuffix .ml, $(OBJ))
CMO = $(addsuffix .cmo, $(OBJ))
CMX = $(addsuffix .cmx, $(OBJ))

OCAMLOPT=ocamlopt -noassert -inline 1000

all: $(MAIN).$(OCAMLBEST)

extract: $(GENML)

doc:
	$(WHY3) doc ../gcd.mlw
	$(WHY3) session html .

$(MAIN).opt: $(CMX)  $(MAIN).cmx
	$(OCAMLOPT) $(INCLUDE) $(BIGINTLIB).cmxa -o $@ $^

$(MAIN).cmx: $(CMX)

$(GENML): ../gcd.mlw
	$(WHY3) extract -D ocaml64 -L .. -o $@ gcd.EuclideanAlgorithm63

%.cmx: %.ml
	$(OCAMLOPT) $(INCLUDE) -annot -c $<

clean::
	rm -f $(GENML) *.cm[xio] *.o *.annot $(MAIN).opt $(MAIN).byte
	rm -f gcd__*.ml*

# javascript


JSMAIN=jsmain

JSOCAMLC=ocamlfind ocamlc -package js_of_ocaml -package js_of_ocaml-ppx -package js_of_ocaml-lwt

$(JSMAIN).js: $(JSMAIN).byte
	js_of_ocaml --pretty --noinline $(JSMAIN).byte


$(JSMAIN).byte: $(ML) jsmain.ml
	$(JSOCAMLC) $(INCLUDE) -o $@ -linkpkg $^


%.cmo: %.ml
	$(JSOCAMLC) $(INCLUDE) -annot -c $<

%.cmi: %.mli
	$(JSOCAMLC) $(INCLUDE) -annot -c $<


clean::
	rm -f *.cm[io] $(NAME).byte $(NAME).js

=== examples/prover/Makefile ===

BENCH ?= no

ifeq ($(BENCH),yes)
  WHY3=../../bin/why3.opt
  WHY3SHARE=../../share
else
  ifeq ($(BINDIR),)
    WHY3=why3
  else
    WHY3=$(BINDIR)/why3
  endif
  WHY3SHARE=$(shell $(WHY3) --print-datadir)
endif

include $(WHY3SHARE)/Makefile.config

ifeq ($(BENCH),yes)
  INCLUDE += -I ../../lib/why3
endif


BD=prover
OCAMLC=ocamlopt.opt
INCLUDES=$(INCLUDEALL) -I ../../plugins/tptp
LIBS=unix.cmxa nums.cmxa $(BIGINTLIB).cmxa dynlink.cmxa str.cmxa menhirLib.cmx zip.cmxa why3.cmxa why3extract.cmxa tptp_ast.cmx tptp_typing.cmx tptp_parser.cmx tptp_lexer.cmx
WHY3FLAGS=-L . --debug=ignore_unused_vars
MLFLAGS=
MLIFLAGS=
MLEXECFLAGS=

.PHONY: clean depend extract replay

$(BD): $(BD).cmx run.cmx
	echo "WHY3SHARE="$(WHY3SHARE)
	$(OCAMLC) $(INCLUDES) $(LIBS) $(MLFLAGS) $(MLEXECFLAGS) \
		-o $(BD) $^

extract: $(ML)

$(BD).ml:
	why3 $(WHY3FLAGS) extract -D ocaml64 -o $(BD).ml ProverTest.mlw

%.cmx: %.ml
	$(OCAMLC) $(INCLUDES) $(MLFLAGS) -c $<

.depend: Makefile $(ML)
	ocamldep.opt -I $(BD) $(ML) > .depend

ifneq "$(MAKECMDGOALS:clean%=clean)" "clean"
ifneq "$(MAKECMDGOALS:extract%=extract)" "extract"
ifneq "$(MAKECMDGOALS:extract%=replay)" "replay"
include .depend
endif
endif
endif

replay:
	@printf "===================================\n"
	@printf "Starting time (UTC): "
	@date --utc +%H:%M
	@printf "===================================\n"
	@for i in *.mlw; do \
		printf "Replaying $$i..." ; \
		why3 $(WHY3FLAGS) replay -q `basename $$i .mlw` ; \
	 done
	@printf "===================================\n"
	@printf "Ending time (UTC): "
	@date --utc +%H:%M
	@printf "===================================\n"

depend: .depend

clean:
	rm -f $(BD)/*.o $(BD)/*.cmi $(BD)/*.cmx
	rm -f $(BD)*.ml
	rm -f *~ *.o *.cmi *.cmx build/prover

=== examples/vstte12_combinators/Makefile ===

BENCH ?= no

ifeq ($(BENCH),yes)
  WHY3=../../bin/why3.opt
  WHY3SHARE=../../share
else
  ifeq ($(BINDIR),)
    WHY3=why3
  else
    WHY3=$(BINDIR)/why3
  endif
  WHY3SHARE=$(shell $(WHY3) --print-datadir)
endif

include $(WHY3SHARE)/Makefile.config

ifeq ($(BENCH),yes)
  INCLUDE += -I ../../lib/why3
endif

MAIN=main
GEN=vstte12_combinators
OBJ=$(GEN) parse

GENML = $(addsuffix .ml, $(GEN))
ML = $(addsuffix .ml, $(OBJ))
CMO = $(addsuffix .cmo, $(OBJ))
CMX = $(addsuffix .cmx, $(OBJ))

OCAMLOPT=ocamlopt -noassert -inline 1000

all: $(MAIN).$(OCAMLBEST)

extract: $(GENML)

doc:
	$(WHY3) doc ../vstte12_combinators.mlw
	$(WHY3) session html .

$(MAIN).opt: $(CMX)  $(MAIN).cmx
	$(OCAMLOPT) $(INCLUDE) $(BIGINTLIB).cmxa -o $@ $^

$(MAIN).cmx: $(CMX)

$(GENML): ../vstte12_combinators.mlw
	$(WHY3) extract -D ocaml64 -o $@ $<

%.cmx: %.ml
	$(OCAMLOPT) $(INCLUDE) -annot -c $<

clean::
	rm -f $(GENML) *.cm[xio] *.o *.annot $(MAIN).opt $(MAIN).byte
	rm -f vstte12_combinators__*.ml*

# javascript


JSMAIN=jsmain

JSOCAMLC=ocamlfind ocamlc -package js_of_ocaml -package js_of_ocaml-ppx -package js_of_ocaml-lwt

$(JSMAIN).js: $(JSMAIN).byte
	js_of_ocaml --pretty --noinline +nat.js $(JSMAIN).byte


$(JSMAIN).byte: $(CMO) jsmain.ml
#	$(JSOCAMLC) $(INCLUDE) -o $@ -linkpkg $^
	$(JSOCAMLC) $(INCLUDE) $(BIGINTLIB).cma -o $@ -linkpkg $^


%.cmo: %.ml
	$(JSOCAMLC) $(INCLUDE) -annot -c $<

%.cmi: %.mli
	$(JSOCAMLC) $(INCLUDE) -annot -c $<


clean::
	rm -f *.cm[io] $(NAME).byte $(NAME).js

=== debian/changelog ===
why3 (1.5.1-1) unstable; urgency=medium

  * New upstream release.
  * Supports z3 until 4.11.0 
  * Standards-Version 4.6.1 (no change)
  * Add lintian override for test file with national character encoding

 -- Ralf Treinen <treinen@debian.org>  Wed, 19 Oct 2022 03:37:35 +0200

=== debian/control ===
--- 
+++ 
@@ -25,7 +25,7 @@
   texlive-bibtex-extra,
   tex-gyre,
   graphviz
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Rules-Requires-Root: no
 Homepage: http://why3.lri.fr/
 Vcs-Git: https://salsa.debian.org/ocaml-team/why3.git
@@ -37,7 +37,7 @@
   ${shlibs:Depends},
   ${ocaml:Depends},
   ${misc:Depends},
-Recommends: cvc4 (<< 1.9) | spass | z3 (<< 4.8.16) | alt-ergo (>= 2.0.0)
+Recommends: cvc4 (<< 1.9) | spass | z3 (<< 4.11.1) | alt-ergo (>= 2.0.0)
 Suggests: why3-examples
 Description: Software verification platform
  Why3 is a platform for deductive program verification. It provides a

=== debian/tests/control ===
--- 
+++ 
@@ -11,5 +11,5 @@
 Restrictions: skip-not-installable
 
 Tests: why3+z3
-Depends:why3, z3 (<< 4.8.16)
+Depends:why3, z3 (<< 4.11.1)
 Restrictions: skip-not-installable

## why3 1.6.0

=== examples/c_cursor/Makefile ===
BENCH ?= no

ifeq ($(BENCH),yes)
  WHY3=../../bin/why3.opt
else
  ifeq ($(BINDIR),)
    WHY3=why3
  else
    WHY3=$(BINDIR)/why3
  endif
endif

.PHONY: clean extract

clean:
	rm -rf build

extract:
	mkdir -p build
	$(WHY3) extract -D cursor.drv -D c -L . --recursive --modular \
		--interface --debug=c_no_error_msgs -o build/ ccursor.PtrCursor

build/tests: build/ptrcursor.c
	gcc -Wall -g -pedantic -Wno-unused-function -std=c11 build/ptrcursor.c -Ibuild -o build/tests

=== examples/defunctionalization/Makefile ===


BENCH ?= no

ifeq ($(BENCH),yes)
  WHY3=../../bin/why3.opt
  WHY3SHARE=../../share
else
  ifeq ($(BINDIR),)
    WHY3=why3
  else
    WHY3=$(BINDIR)/why3
  endif
  WHY3SHARE=$(shell $(WHY3) --print-datadir)
endif

include $(WHY3SHARE)/Makefile.config

ifeq ($(BENCH),yes)
  INCLUDE += -I ../../lib/why3
endif


MAIN = main
OBJ = defunctionalization
ML  = $(addsuffix .ml, $(OBJ))
CMO = $(addsuffix .cmo, $(OBJ))
CMX = $(addsuffix .cmx, $(OBJ))

OCAMLOPT = ocamlopt -noassert -inline 1000

all: $(MAIN).opt

extract: $(ML)

doc:
	$(WHY3) doc ../defunctionalization.mlw
	$(WHY3) session html ../defunctionalization.mlw
	@echo firefox ../defunctionalization.html why3session.html

$(MAIN).byte: $(CMO) $(MAIN).cmo
	ocamlc -g $(INCLUDE) $(BIGINTLIB).cma -o $@ $^

$(MAIN).opt: $(CMX) $(MAIN).cmx
	$(OCAMLOPT) $(INCLUDE) $(BIGINTLIB).cmxa -o $@ $^

$(MAIN).cmx: $(CMX)

$(ML): ../defunctionalization.mlw
	$(WHY3) extract -D ocaml64 --recursive -L .. -o $@ \
		defunctionalization.DirectSem \
		defunctionalization.CPS \
		defunctionalization.Defunctionalization

%.cmx: %.ml
	$(OCAMLOPT) $(INCLUDE) -annot -c $<

%.cmo: %.ml
	ocamlc $(INCLUDE) -annot -g -c $<

%.cmi: %.mli
	ocamlc $(INCLUDE) -annot -g -c $<

clean::
	rm -f $(ML) *.cm[xio] $(MAIN).opt

=== examples/string_base64_encoding/Makefile ===

BENCH ?= no

ifeq ($(BENCH),yes)
  WHY3=../../bin/why3.opt
  WHY3SHARE=../../share
else
  ifeq ($(BINDIR),)
    WHY3=why3
  else
    WHY3=$(BINDIR)/why3
  endif
  WHY3SHARE=$(shell $(WHY3) --print-datadir)
endif

include $(WHY3SHARE)/Makefile.config

ifeq ($(BENCH),yes)
  INCLUDE += -I ../../lib/why3
endif

MAIN=main
GEN=base64
OBJ=$(GEN)

GENML = $(addsuffix .ml, $(GEN))
ML = $(addsuffix .ml, $(OBJ))
CMO = $(addsuffix .cmo, $(OBJ))
CMX = $(addsuffix .cmx, $(OBJ))

OCAMLOPT=ocamlopt -noassert -inline 1000

all: $(MAIN).$(OCAMLBEST)

extract: $(GENML)

doc:
	$(WHY3) doc ../string_base64_encoding.mlw
	$(WHY3) session html .

$(MAIN).opt: $(CMX)  $(MAIN).cmx
	$(OCAMLOPT) $(INCLUDE) $(BIGINTLIB).cmxa -o $@ $^

$(MAIN).cmx: $(CMX)

$(GENML): ../string_base64_encoding.mlw
	$(WHY3) extract -D ocaml64 -L .. -o $@ ../string_base64_encoding.mlw

%.cmx: %.ml
	$(OCAMLOPT) $(INCLUDE) -annot -c $<

clean::
	rm -f $(GENML) *.cm[xio] *.o *.annot $(MAIN).opt $(MAIN).byte
	rm -f gcd__*.ml*


%.cmo: %.ml
	$(JSOCAMLC) $(INCLUDE) -annot -c $<

%.cmi: %.mli
	$(JSOCAMLC) $(INCLUDE) -annot -c $<


clean::
	rm -f *.cm[io] $(NAME).byte $(NAME).js

=== examples/sudoku/Makefile ===

BENCH ?= no

ifeq ($(BENCH),yes)
  WHY3=../../bin/why3.opt
  WHY3SHARE=../../share
else
  ifeq ($(BINDIR),)
    WHY3=why3
  else
    WHY3=$(BINDIR)/why3
  endif
  WHY3SHARE=$(shell $(WHY3) --print-datadir)
endif

include $(WHY3SHARE)/Makefile.config

ifeq ($(BENCH),yes)
  INCLUDE += -I ../../lib/why3
endif

MAIN=main
GEN =sudoku
OBJ=$(GEN)

GENML = $(addsuffix .ml, $(GEN))
ML = $(addsuffix .ml, $(OBJ))
CMO = $(addsuffix .cmo, $(OBJ))
CMX = $(addsuffix .cmx, $(OBJ))

OCAMLOPT = ocamlopt -noassert -inline 1000

all: $(MAIN).opt

extract: $(GENML)

doc:
	$(WHY3) doc ../sudoku.mlw
	$(WHY3) session html .

$(MAIN).byte: $(CMO) $(MAIN).cmo
	ocamlc -g $(INCLUDE) $(BIGINTLIB).cma -o $@ $^

$(MAIN).opt: $(CMX) $(MAIN).cmx
	$(OCAMLOPT) $(INCLUDE) $(BIGINTLIB).cmxa -o $@ $^

$(MAIN).cmx: $(CMX)

$(GENML): ../sudoku.mlw
	$(WHY3) extract -D ocaml64 --recursive -o $@ -L .. sudoku.Test

# javascript


JSMAIN=jsmain

JSOCAMLC=ocamlfind ocamlc -package js_of_ocaml -package js_of_ocaml-ppx -package js_of_ocaml-lwt

$(JSMAIN).js: $(JSMAIN).byte
	js_of_ocaml +nat.js $(JSMAIN).byte

$(JSMAIN).byte: $(CMO) $(JSMAIN).cmo
	$(JSOCAMLC) $(INCLUDE) $(BIGINTLIB).cma -o $@ -linkpkg $^

%.cmo: %.ml
	$(JSOCAMLC) $(INCLUDE) -annot -c $<

%.cmi: %.mli
	$(JSOCAMLC) $(INCLUDE) -annot -c $<

%.cmx: %.ml
	$(OCAMLOPT) $(INCLUDE) -annot -c $<

clean::
	rm -f $(GENML) *.annot *.o *.cm[xio] $(MAIN).opt $(MAIN).byte
	rm -f sudoku__*.ml why3__*.ml
	rm -f int__Int.ml map__Map.ml array__Array.ml

=== bench/extraction/test/Makefile ===
include ../../../share/Makefile.config

WHY3 = ../../../bin/why3.$(OCAMLBEST)

.PHONY: extract doc

main.opt: test.ml main.ml
	ocamlopt $(INCLUDE) $(BIGINTLIB).cmxa $^ -o main.opt

extract: test.ml

doc:

%.ml: ../%.mlw
	$(WHY3) extract -D ocaml64 $< > $@

%.cmo: %.ml
	ocamlc $(INCLUDE) -c $<

%.cmx: %.ml
	ocamlopt $(INCLUDE) -c $<

clean::
	rm -f test.ml main.opt *.cm*

=== debian/changelog ===
why3 (1.6.0-1build7) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 15:40:35 +1100

why3 (1.6.0-1build6) noble; urgency=medium

  * No-change rebuild against libglib2.0-0t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 11 Mar 2024 23:53:10 +0000

why3 (1.6.0-1build5) noble; urgency=medium

  * No-change rebuild against libglib2.0-0t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 08 Mar 2024 07:59:18 +0000

why3 (1.6.0-1build4) noble; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 22 Feb 2024 08:36:24 +0100

why3 (1.6.0-1build3) noble; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 19 Feb 2024 07:57:17 +0100

why3 (1.6.0-1build2) noble; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 17 Feb 2024 01:24:00 +0100

why3 (1.6.0-1build1) noble; urgency=medium

  * Rebuild against new OCAML ABI.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 04 Nov 2023 20:12:50 +0100

why3 (1.6.0-1) unstable; urgency=medium

  * Team upload
  * New upstream release
  * Depend on ocaml instead of transitional ocaml-nox
  * Bump Standard-Version to 4.6.2

 -- Stéphane Glondu <glondu@debian.org>  Fri, 08 Sep 2023 07:09:51 +0200

=== debian/control ===
--- 
+++ 
@@ -1,12 +1,13 @@
 Source: why3
 Section: math
 Priority: optional
-Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
 Uploaders: Ralf Treinen <treinen@debian.org>
 Build-Depends:
   debhelper-compat (= 13), dh-ocaml,
   autoconf,
-  ocaml-nox (>= 4.05.5),
+  ocaml,
   ocaml-findlib,
   menhir (>= 20200123),
   libmenhir-ocaml-dev (>= 20200123),
@@ -25,7 +26,7 @@
   texlive-bibtex-extra,
   tex-gyre,
   graphviz
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Rules-Requires-Root: no
 Homepage: http://why3.lri.fr/
 Vcs-Git: https://salsa.debian.org/ocaml-team/why3.git

=== debian/rules ===
--- 
+++ 
@@ -12,6 +12,7 @@
 	autoconf
 	dh_auto_configure -- \
 		--disable-emacs-compilation \
+		--disable-coq-libs \
 		--libdir=/usr/lib/ocaml
 
 override_dh_auto_build-arch:

=== debian/watch ===
version=4
https://why3.gitlabpages.inria.fr/releases/ .*/why3-(.*)\.tar\.gz

## why3 1.7.2

=== examples/prover/Makefile ===
BENCH ?= no

ifeq ($(BENCH),yes)
  WHY3=../../bin/why3.opt
  WHY3SHARE=../../share
else
  ifeq ($(BINDIR),)
    WHY3=why3
  else
    WHY3=$(BINDIR)/why3
  endif
  WHY3SHARE=$(shell $(WHY3) --print-datadir)
endif

include $(WHY3SHARE)/Makefile.config

ifeq ($(BENCH),yes)
  INCLUDE += -I ../../lib/why3
endif


INCLUDES=$(INCLUDE) -I ../../plugins/tptp
LIBS=$(BIGINTLIB).cmxa why3.cmxa tptp_typing.cmx tptp_parser.cmx tptp_lexer.cmx
WHY3FLAGS=-L . --warn-off=unused_variable
PKGS=$(addprefix -package ,$(EXTPKGS))

.PHONY: clean doc extract replay

main.opt: prover.cmx run.cmx
	$(OCAMLFIND) ocamlopt $(PKGS) -linkpkg $(INCLUDES) $(LIBS) -o $@ $^

extract: prover.ml

prover.ml:
	$(WHY3) $(WHY3FLAGS) extract -D ocaml64 -o prover.ml ProverTest.mlw

%.cmx: %.ml
	$(OCAMLFIND) ocamlopt $(PKGS) $(INCLUDES) -c $<

doc:

replay:
	@printf "===================================\n"
	@printf "Starting time (UTC): "
	@date --utc +%H:%M
	@printf "===================================\n"
	@for i in *.mlw; do \
		printf "Replaying $$i..." ; \
		$(WHY3) $(WHY3FLAGS) replay -q `basename $$i .mlw` ; \
	 done
	@printf "===================================\n"
	@printf "Ending time (UTC): "
	@date --utc +%H:%M
	@printf "===================================\n"

clean:
	rm -f *.o *.cmi *.cmx prover.ml main.opt

=== debian/changelog ===
why3 (1.7.2-2build2) plucky; urgency=medium

  * Rebuild against new OCAML ABI.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 02 Jan 2025 18:05:35 +0100

why3 (1.7.2-2build1) oracular; urgency=medium

  * No-change rebuild for OCaml ABIs.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 06 Sep 2024 17:04:30 +0200

why3 (1.7.2-2) unstable; urgency=medium

  * Team upload
  * Do not hardcode /usr/lib/ocaml
  * Depend on ocaml-native-compilers in tests for now

 -- Stéphane Glondu <glondu@debian.org>  Tue, 13 Aug 2024 01:43:15 +0200

why3 (1.7.2-1) unstable; urgency=medium

  * New upstream release.
  * debian/clean: add doc/.doctrees (closes: #1046969), remove cruft
  * debian/watch: use release tags of INRIA's gitlab
  * debian/rules: update url of external mathjax resources, which are
    replaced by locally installed mathjax.
  * The alt-ergo package is no longer in debian: drop it from Recommends,
    and drop the corresponding as-installed test.
  * Standards-Version 4.7.0 (no change)

 -- Ralf Treinen <treinen@debian.org>  Mon, 12 Aug 2024 11:54:59 +0200

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: why3
 Section: math
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
+Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
 Uploaders: Ralf Treinen <treinen@debian.org>
 Build-Depends:
   debhelper-compat (= 13), dh-ocaml,
@@ -26,7 +25,7 @@
   texlive-bibtex-extra,
   tex-gyre,
   graphviz
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Rules-Requires-Root: no
 Homepage: http://why3.lri.fr/
 Vcs-Git: https://salsa.debian.org/ocaml-team/why3.git
@@ -38,7 +37,7 @@
   ${shlibs:Depends},
   ${ocaml:Depends},
   ${misc:Depends},
-Recommends: cvc4 (<< 1.9) | spass | z3 (<< 4.11.1) | alt-ergo (>= 2.0.0)
+Recommends: cvc4 (<< 1.9) | spass | z3 (<< 4.11.1)
 Suggests: why3-examples
 Description: Software verification platform
  Why3 is a platform for deductive program verification. It provides a

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/ocaml/ocamlvars.mk
OCAML_NATIVE_ARCHS := $(subst lpia,,$(OCAML_NATIVE_ARCHS))

BUILDDIR=debian/tmp
export OCAMLFIND_DESTDIR=$(OCAML_STDLIB_DIR)

%:
	dh $@ --with ocaml,tex

override_dh_auto_configure:
	autoconf
	dh_auto_configure -- \
		--disable-emacs-compilation \
		--disable-coq-libs \
		--libdir=$(OCAML_STDLIB_DIR)

override_dh_auto_build-arch:
	$(MAKE) all byte

MATHJAXBAD="https://cdn\.jsdelivr\.net/npm/mathjax.*\.js"
MATHJAXLOCAL="/usr/share/javascript/mathjax/MathJax.js"
override_dh_auto_build-indep:
	$(MAKE) doc
	cd doc/html; \
	for f in *.html; do \
	  sed -e "s|$(MATHJAXBAD)|$(MATHJAXLOCAL)|" $$f > $$f.out; \
	  mv $$f.out $$f; \
	done

override_dh_auto_install:
	# do nothing

override_dh_install-arch: build-arch
	$(MAKE) install install-lib DESTDIR=$(CURDIR)/$(BUILDDIR)
	dh_install -a -XLICENSE

override_dh_install-indep:
	# do nothing

override_dh_installexamples:
	dh_installexamples
	if [ -d debian/why3-examples/usr/share/doc/why3-examples/examples ]; \
	then \
	  find debian/why3-examples/usr/share/doc/why3-examples/examples \
	    -name why3shapes.gz \
	    -exec sh -c 'if [ $$(zcat {} | wc -c) -eq 0 ]; then \rm {}; fi' \;;\
	fi

override_dh_compress:
	dh_compress -Xmanual.pdf

ifneq ($(wildcard debian/why3$(OCAML_STDLIB_DIR)/why3/commands/why3ide.cmxs),)
  WHY3IDE_UNITS := $(shell ocamlobjinfo debian/why3$(OCAML_STDLIB_DIR)/why3/commands/why3ide.cmxs | sed -n 's/Name: //p' | xargs echo | tr ' ' ,)
else
  WHY3IDE_UNITS := $(shell ocamlobjinfo debian/why3$(OCAML_STDLIB_DIR)/why3/commands/why3ide.cma | sed -n 's/Unit name: //p' | xargs echo | tr ' ' ,)
endif

WHY3HYPO_UNITS := $(shell ocamlobjinfo debian/why3$(OCAML_STDLIB_DIR)/why3/plugins/hypothesis_selection.cma | sed -n 's/Unit name: //p' | xargs echo | tr ' ' ,)

override_dh_ocaml:
	dh_ocaml --nodefined-map=why3:$(WHY3IDE_UNITS),$(WHY3HYPO_UNITS)

=== debian/tests/control ===
Tests: why3+cvc4
Depends: why3, cvc4 (<< 1.9), ocaml-native-compilers
Restrictions: skip-not-installable

Tests: why3+spass
Depends:why3, spass, ocaml-native-compilers
Restrictions: skip-not-installable

Tests: why3+z3
Depends:why3, z3 (<< 4.11.1), ocaml-native-compilers
Restrictions: skip-not-installable

## why3 1.8.0

=== examples/defunctionalization/Makefile ===
--- 
+++ 
@@ -39,10 +39,10 @@
 	@echo firefox ../defunctionalization.html why3session.html
 
 $(MAIN).byte: $(CMO) $(MAIN).cmo
-	ocamlc -g $(INCLUDE) $(BIGINTLIB).cma -o $@ $^
+	ocamlc -g $(INCLUDE) zarith.cma -o $@ $^
 
 $(MAIN).opt: $(CMX) $(MAIN).cmx
-	$(OCAMLOPT) $(INCLUDE) $(BIGINTLIB).cmxa -o $@ $^
+	$(OCAMLOPT) $(INCLUDE) zarith.cmxa -o $@ $^
 
 $(MAIN).cmx: $(CMX)

=== examples/vstte12_combinators/Makefile ===
--- 
+++ 
@@ -39,7 +39,7 @@
 	$(WHY3) session html .
 
 $(MAIN).opt: $(CMX)  $(MAIN).cmx
-	$(OCAMLOPT) $(INCLUDE) $(BIGINTLIB).cmxa -o $@ $^
+	$(OCAMLOPT) $(INCLUDE) zarith.cmxa -o $@ $^
 
 $(MAIN).cmx: $(CMX)
 
@@ -66,7 +66,7 @@
 
 $(JSMAIN).byte: $(CMO) jsmain.ml
 #	$(JSOCAMLC) $(INCLUDE) -o $@ -linkpkg $^
-	$(JSOCAMLC) $(INCLUDE) $(BIGINTLIB).cma -o $@ -linkpkg $^
+	$(JSOCAMLC) $(INCLUDE) zarith.cma -o $@ -linkpkg $^
 
 
 %.cmo: %.ml

=== bench/extraction/interface1/Makefile ===
include ../../../share/Makefile.config

WHY3 = ../../../bin/why3.$(OCAMLBEST)

.PHONY: extract doc

main.opt: interface1.ml main.ml
	ocamlopt $(INCLUDE) zarith.cmxa $^ -o main.opt

extract: interface1.ml

doc:

%.ml: %.mlw
	$(WHY3) extract -D ocaml64 -L . --recursive interface1.Main > $@

%.cmo: %.ml
	ocamlc $(INCLUDE) -c $<

%.cmx: %.ml
	ocamlopt $(INCLUDE) -c $<

clean::
	rm -f interface1.ml main.opt *.cm*

=== debian/changelog ===
why3 (1.8.0-2) unstable; urgency=medium

  * Team upload
  * Add Breaks+Replaces to avoid file conflict (Closes: #1093827)

 -- Stéphane Glondu <glondu@debian.org>  Sun, 02 Feb 2025 07:37:18 +0100

why3 (1.8.0-1) unstable; urgency=medium

  * New upstream release.
  * Stop building the documentation packages:
    - debian/control: disable why3-doc-* packages
    - debian/rules: disable override_dh_auto_build-arch
    - debian-rules: disable Build-Depends-Indep
  * Create a symlink from /usr/lib/ocaml/why3 to the why3 library in order
    to work around a bug in why3, which does not properly take into account
    the --libdir option to ./configure.
  * Dependency and Test-Dependency on provers:
    - bump z3 to version << 4.14
    - add cvc5 << 1.3
  * Add an as-installed test with cvc5

 -- Ralf Treinen <treinen@debian.org>  Wed, 22 Jan 2025 21:27:21 +0100

=== debian/control ===
--- 
+++ 
@@ -17,14 +17,14 @@
   libocamlgraph-ocaml-dev (>= 1.8.2),
   liblablgtk3-ocaml-dev, liblablgtksourceview3-ocaml-dev,
   tex-common
-Build-Depends-Indep:
-  python3-sphinx, python3-sphinxcontrib.bibtex,
-  texlive-plain-generic,
-  texlive-latex-recommended, texlive-latex-extra,
-  texlive-fonts-recommended,
-  texlive-bibtex-extra,
-  tex-gyre,
-  graphviz
+# Build-Depends-Indep:
+#   python3-sphinx, python3-sphinxcontrib.bibtex,
+#   texlive-plain-generic,
+#   texlive-latex-recommended, texlive-latex-extra,
+#   texlive-fonts-recommended,
+#   texlive-bibtex-extra,
+#   tex-gyre,
+#   graphviz
 Standards-Version: 4.7.0
 Rules-Requires-Root: no
 Homepage: http://why3.lri.fr/
@@ -37,8 +37,10 @@
   ${shlibs:Depends},
   ${ocaml:Depends},
   ${misc:Depends},
-Recommends: cvc4 (<< 1.9) | spass | z3 (<< 4.11.1)
+Recommends: cvc4 (<< 1.9) | cvc5 (<< 1.3) | spass | z3 (<< 4.14)
 Suggests: why3-examples
+Breaks: libwhy3-ocaml-dev (<< 1.8), why3-coq (<< 1.8)
+Replaces: libwhy3-ocaml-dev (<< 1.8), why3-coq (<< 1.8)
 Description: Software verification platform
  Why3 is a platform for deductive program verification. It provides a
  rich language for specification and programming, called WhyML, and
@@ -79,22 +81,22 @@
  and pure logical verification tasks, for the why3 software verification
  platform.
 
-Package: why3-doc-html
-Architecture: all
-Depends: ${misc:Depends},
-  libjs-jquery,
-  libjs-underscore,
-  libjs-mathjax,
-  libjs-sphinxdoc
-Suggests: why3
-Description: HTML Documentation of the why3 verification platform
- This package contains the tutorial and reference manual of the
- why3 verification platform in HTML format.
+# Package: why3-doc-html
+# Architecture: all
+# Depends: ${misc:Depends},
+#   libjs-jquery,
+#   libjs-underscore,
+#   libjs-mathjax,
+#   libjs-sphinxdoc
+# Suggests: why3
+# Description: HTML Documentation of the why3 verification platform
+#  This package contains the tutorial and reference manual of the
+#  why3 verification platform in HTML format.
 
-Package: why3-doc-pdf
-Architecture: all
-Depends: ${misc:Depends}
-Suggests: why3
-Description: PDF Documentation of the why3 verification platform
- This package contains the tutorial and reference manual of the
- why3 verification platform in PDF format.
+# Package: why3-doc-pdf
+# Architecture: all
+# Depends: ${misc:Depends}
+# Suggests: why3
+# Description: PDF Documentation of the why3 verification platform
+#  This package contains the tutorial and reference manual of the
+#  why3 verification platform in PDF format.

=== debian/rules ===
--- 
+++ 
@@ -19,15 +19,15 @@
 override_dh_auto_build-arch:
 	$(MAKE) all byte
 
-MATHJAXBAD="https://cdn\.jsdelivr\.net/npm/mathjax.*\.js"
-MATHJAXLOCAL="/usr/share/javascript/mathjax/MathJax.js"
-override_dh_auto_build-indep:
-	$(MAKE) doc
-	cd doc/html; \
-	for f in *.html; do \
-	  sed -e "s|$(MATHJAXBAD)|$(MATHJAXLOCAL)|" $$f > $$f.out; \
-	  mv $$f.out $$f; \
-	done
+# MATHJAXBAD="https://cdn\.jsdelivr\.net/npm/mathjax.*\.js"
+# MATHJAXLOCAL="/usr/share/javascript/mathjax/MathJax.js"
+# override_dh_auto_build-indep:
+# 	$(MAKE) doc
+# 	cd doc/html; \
+# 	for f in *.html; do \
+# 	  sed -e "s|$(MATHJAXBAD)|$(MATHJAXLOCAL)|" $$f > $$f.out; \
+# 	  mv $$f.out $$f; \
+# 	done
 
 override_dh_auto_install:
 	# do nothing

## why3 1.8.1

=== examples/gcd/Makefile ===
--- 
+++ 
@@ -39,7 +39,7 @@
 	$(WHY3) session html .
 
 $(MAIN).opt: $(CMX)  $(MAIN).cmx
-	$(OCAMLOPT) $(INCLUDE) $(BIGINTLIB).cmxa -o $@ $^
+	$(OCAMLOPT) $(INCLUDE) zarith.cmxa -o $@ $^
 
 $(MAIN).cmx: $(CMX)

=== examples/prover/Makefile ===
--- 
+++ 
@@ -20,7 +20,7 @@
 
 
 INCLUDES=$(INCLUDE) -I ../../plugins/tptp
-LIBS=$(BIGINTLIB).cmxa why3.cmxa tptp_typing.cmx tptp_parser.cmx tptp_lexer.cmx
+LIBS=why3.cmxa tptp_typing.cmx tptp_parser.cmx tptp_lexer.cmx
 WHY3FLAGS=-L . --warn-off=unused_variable
 PKGS=$(addprefix -package ,$(EXTPKGS))

=== examples/sudoku/Makefile ===
--- 
+++ 
@@ -39,10 +39,10 @@
 	$(WHY3) session html .
 
 $(MAIN).byte: $(CMO) $(MAIN).cmo
-	ocamlc -g $(INCLUDE) $(BIGINTLIB).cma -o $@ $^
+	ocamlc -g $(INCLUDE) zarith.cma -o $@ $^
 
 $(MAIN).opt: $(CMX) $(MAIN).cmx
-	$(OCAMLOPT) $(INCLUDE) $(BIGINTLIB).cmxa -o $@ $^
+	$(OCAMLOPT) $(INCLUDE) zarith.cmxa -o $@ $^
 
 $(MAIN).cmx: $(CMX)
 
@@ -60,7 +60,7 @@
 	js_of_ocaml +nat.js $(JSMAIN).byte
 
 $(JSMAIN).byte: $(CMO) $(JSMAIN).cmo
-	$(JSOCAMLC) $(INCLUDE) $(BIGINTLIB).cma -o $@ -linkpkg $^
+	$(JSOCAMLC) $(INCLUDE) zarith.cma -o $@ -linkpkg $^
 
 %.cmo: %.ml
 	$(JSOCAMLC) $(INCLUDE) -annot -c $<

=== debian/changelog ===
why3 (1.8.1-1) unstable; urgency=medium

  * Team upload
  * New upstream release (Closes: #1098092)

 -- Stéphane Glondu <glondu@debian.org>  Fri, 12 Sep 2025 14:59:57 +0200

why3 (1.8.0-3) experimental; urgency=medium

  * Update home page.
  * Build again the documentation packages.
  * Standards-Version 4.7.2 (no change)

 -- Ralf Treinen <treinen@debian.org>  Sun, 20 Apr 2025 14:13:02 +0200

=== debian/rules ===
--- 
+++ 
@@ -19,15 +19,19 @@
 override_dh_auto_build-arch:
 	$(MAKE) all byte
 
-# MATHJAXBAD="https://cdn\.jsdelivr\.net/npm/mathjax.*\.js"
-# MATHJAXLOCAL="/usr/share/javascript/mathjax/MathJax.js"
-# override_dh_auto_build-indep:
-# 	$(MAKE) doc
-# 	cd doc/html; \
-# 	for f in *.html; do \
-# 	  sed -e "s|$(MATHJAXBAD)|$(MATHJAXLOCAL)|" $$f > $$f.out; \
-# 	  mv $$f.out $$f; \
-# 	done
+MATHJAXBAD="https://cdn\.jsdelivr\.net/npm/mathjax.*\.js"
+MATHJAXLOCAL="/usr/share/javascript/mathjax/MathJax.js"
+override_dh_auto_build-indep:
+	# we need a "local" installation since building the documentation
+	# requires running why3.
+	./configure --enable-local
+	$(MAKE)
+	$(MAKE) doc
+	cd doc/html; \
+	for f in *.html; do \
+	  sed -e "s|$(MATHJAXBAD)|$(MATHJAXLOCAL)|" $$f > $$f.out; \
+	  mv $$f.out $$f; \
+	done
 
 override_dh_auto_install:
 	# do nothing
